<?php

namespace Drupal\text_with_title\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\text\Plugin\Field\FieldWidget\TextareaWidget;
/**
 * Plugin implementation of the 'TextWithTitleWidget' widget.
 *
 * @FieldWidget(
 *   id = "text_with_title_widget",
 *   module = "text_with_title",
 *   label = @Translation("Text with title"),
 *   field_types = {
 *     "text_with_title_field"
 *   }
 * )
 */
class TextWithTitleWidget extends TextareaWidget {

  /**
   * Define the form for the field type.
   *
   * Inside this method we can define the form used to edit the field type.
   *
   * Here there is a list of allowed element types: https://goo.gl/XVd4tA
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state) {
    $element = parent::formElement($items, $delta, $element, $form, $form_state);

    // Title.
    $element['title'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Title'),
      '#default_value' => isset($items[$delta]->title) ?
      $items[$delta]->title : NULL,
      '#empty_value' => '',
      '#placeholder' => $this->t('Title'),
    ];

    return $element;
  }

}
